#!/usr/bin/perl
 
########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "../config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO config.cgi

# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";

#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################

#use FindBin;
#use lib $FindBin::Bin;
use CGI;
use DBI;
use acs;
use obbuild;

&get_setup;
$q = CGI->new;

acs::check_access($username, $password, $q->param('username'), $q->param('password'));

##################################################################################

print "Content-type: text/html\n\n";
if ($q->param('fct') eq "") {&start;} 




#### EDIT FILTER KEYWORDS
	if (($q->param('B1') eq "   Edit   ") and ($q->param('fct') eq "filteraction"))
		{&editkeyw; exit;}
		
#### DELELET FILETER KEYWORDS
	if (($q->param('B1') eq "Delete") and ($q->param('fct')  eq "filteraction"))
		{&deletek; exit;}

#### VIEW BLOCKED LOG
	if (($q->param('B1') eq "View Blocked Log") and ($q->param('fct')  eq "ofunct"))
		{&viewblocked; exit;}

#### DELETE BLOCKED LOG
	if (($q->param('B1') eq "Delete Blocked Log") and ($q->param('fct')  eq "ofunct"))
		{&deleteblocked; exit;}

if ($q->param('fct') eq "savededited"){&savededited;}

if (($q->param('B1') eq "Add New Filter") and ($q->param('fct') eq "ofunct"))
	{
	&addnewfilter; exit;
	}

if ($q->param('fct') eq "addfilter"){&addfilter; exit;}


#########


sub viewblocked
{


print <<END_OF_TP;

<html>
<head>
<title>Blocked Log</title>
</head>
<body>
<table border="0" cellpadding="0" cellspacing="0" width="100%">
  <tr>
    <td width="6%" valign="top"><img src="$web_url/add.gif"></td>
    <td width="94%" valign="top"><strong><font face="Arial" size="4" color="#000000">Blocked
    Log<br>
    </font></strong><font face="Verdana" size="1" color="#000000">Lists which Url's have been blocked
    by spam filters. Use the back button of your browser to go back.</font></td>
  </tr>
</table>
<hr noshade size="1" color="#EBEBEB">

END_OF_TP

#########

$ldata = &get_file_contents("$data_dir/sfiltlog.log");
@LOGItems = split (/\n/, $ldata);

print "<font face=\"Verdana\" size=\"1\">";

	foreach $item (@LOGItems)
		{
		@LListItems = split (/:::/, $item);
	
		print "<b>Block Reason:</b> $LListItems[0]<br>";
		print "<b>Email:</b> $LListItems[1]<br>";
		print "<b>Title:</b> $LListItems[2]<br>";
		print "<b>Description:</b> $LListItems[3]<br>";
		print "<b>Keywords:</b> $LListItems[4]<br>";
		print "<b>Url:</b> $LListItems[5] <br><br>";
		
		$listitem = "true";
		}

if ($listitem ne "true") {print "<font face=\"Verdana\" size=\"1\">No New Submissions Has Been Blocked Yet.</font>";}

print "</font></body></html>";


}



sub deleteblocked
{

if (-e "$data_dir/sfiltlog.log")
	{
	unlink "$data_dir/sfiltlog.log";
	}
	else
	{
	acs::problem_popup("Could not find a log to delete."); exit; 
	}

##########

print <<END_OF_DEL;

<html>
<head>
<title>Blocked Log</title>
</head>
<body>
<table border="0" cellpadding="0" cellspacing="0" width="100%">
  <tr>
    <td width="6%" valign="top"><img src="$web_url/add.gif"></td>
    <td width="94%" valign="top"><font face="Arial" size="4" color="#000000"><strong>Blocked
    Log Deleted<br>
    </strong></font><a href="$admin_url/admin42.cgi"><font face="Verdana" size="1"
    color="#000000">Click here to continue</font></a></td>
  </tr>
</table>
<hr noshade size="1" color="#EBEBEB">
</body>
</html>

END_OF_DEL
	
}




sub deletek
{

### CHECK FOR ERRORS

$fildata = &get_file_contents("$data_dir/sfilter.dat");
@fitems = split (/\n/, $fildata);


	for ($ms = 0; $ms < $q->param('maxc'); $ms++)
		{
		$ItemSelected = "C" . $ms;
		
		if ($q->param($ItemSelected) eq "")
			{
			$num = push(@newitems,$fitems[$ms]);
			}
			else
			{
			$DelTrue = "true";
			}

		}


if ($DelTrue eq "true")
	{

	open (FILED, "> $data_dir/sfilter.dat");
		foreach $item (@newitems)
			{
			print FILED $item . "\n";
			}	
	close (FILED);
	
print <<END_OF_DEL;

<html>

<head>
<title>Spam Filter</title>
</head>

<body>

<table border="0" cellpadding="2" cellspacing="1" width="100%">
  <tr>
    <td width="1%" valign="top"><p align="center"><img
    src="$web_url/add.gif"></td>
    <td width="95%" valign="top" align="center"><p align="left"><font face="Arial" size="4"
    color="#000000"><strong>Filter(s) Deleted<br>
    </strong></font><a href="$admin_url/admin42.cgi"><font face="Verdana" size="1">Click Here
    to Continue</font></a></td>
  </tr>
</table>

<hr noshade size="1" color="#C0C0C0">

<p>&nbsp;</p>
</body>
</html>

END_OF_DEL

	}
	else
	{
	acs::problem_popup("You have to check a checkbox next to a keyword to delete it."); 
	exit;
	}

}








sub addnewfilter
{

print <<END_OF_ADDF;

<html>
<head>
<title>Spam Filter</title>
</head>
<body>
<form method="POST" action="$admin_url/admin42.cgi">
  <input type="hidden" name="fct" value="addfilter"><table border="0" cellpadding="2"
  cellspacing="1" width="100%">
    <tr>
      <td width="1%" valign="top"><div align="center"><center><p><img
      src="$web_url/add.gif"></td>
      <td width="95%" valign="top" align="center"><div align="left"><p><font face="Arial"
      size="4" color="#000000"><strong>Add New Spam Filter<br>
      </strong></font><font face="Verdana" size="1">All filters will be referenced when
      end-users makes new submissions. If the keyword (of a filter) matches a new submission, then the
      submission won't be added.</font></td>
    </tr>
  </table>
  <hr noshade size="1" color="#C0C0C0" align="center">
  <div align="center"><center><table border="0" cellpadding="3" cellspacing="1" width="100%"
  bgcolor="#808080">
    <tr>
      <td width="30%" bgcolor="#F5F5F5"><font face="Verdana" size="1">Keyword to Match Against
      Submission:</font></td>
      <td width="70%" bgcolor="#FFFFFF"><input type="text" name="keyword" size="29"
      style="font-family: MS Sans Serif; font-size: 8"></td>
    </tr>
    <tr>
      <td width="30%" bgcolor="#F5F5F5"><font face="Verdana" size="1">Whole or Partial Word
      Match:</font></td>
      <td width="70%" bgcolor="#FFFFFF"><select name="matchmethod" size="1"
      style="font-family: MS Sans Serif; font-size: 8">
        <option value="W">Whole</option>
        <option value="P">Partial</option>
      </select></td>
    </tr>
    <tr>
      <td width="30%" bgcolor="#F5F5F5"><font face="Verdana" size="1">Check For This Keyword in:</font></td>
      <td width="70%" bgcolor="#FFFFFF"><select name="wherematch" size="1"
      style="font-family: MS Sans Serif; font-size: 8">
        <option value="General">Title, Description and Keyword Field</option>
        <option value="Email">Email Field</option>
        <option value="URL">URL Field</option>
        <option value="Referer">Referer</option>
      </select></td>
    </tr>
    <tr>
      <td width="30%" bgcolor="#FFFFFF">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
      </td>
      <td width="70%" bgcolor="#FFFFFF"><input type="submit" value="   Add   " name="B1"
      style="font-family: MS Sans Serif; font-size: 8"></td>
    </tr>
    <tr>
      <td width="100%" bgcolor="#FFFFFF" colspan="2"><font color="#000000" face="Verdana"
      size="1"><strong>Quick Help</strong></font><p><font color="#FF8000" face="Verdana"
      size="1"><strong>&nbsp;&nbsp;&nbsp; Whole or Partial Word Match:</strong></font></p>
      <blockquote>
        <p><font face="Verdana" size="1"><strong>Whole Word Matching<br>
        </strong>'Whole word matching' matches whole words. For example: <strong>Spam</strong><br>
        This will only match <strong>Spam</strong> and not <strong>Spammed<br>
        &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; <br>
        Partial Word Matching<br>
        </strong>'Partial matching' matches any word in words. Let's say you specified <strong>Spam</strong>
        as a keyword; if <strong>Spammed</strong> was found within a submission that submission
        would be blocked because <strong>Spammed</strong> contained the word <strong>Spam</strong></font></p>
      </blockquote>
      <p><font color="#FF8000" face="Verdana" size="1"><strong>&nbsp; &nbsp; Check For This
      Keyword in:</strong></font></p>
      <blockquote>
        <p><font face="Verdana" size="1"><strong>Title, Description and Keyword Field<br>
        </strong>If you choose this to be checked for keyword matches, the <strong>title,
        description and keyword field</strong> in the submission form will be checked for matches.</font></p>
      </blockquote>
      <blockquote>
        <p><font face="Verdana" size="1"><strong>URL Field</strong><br>
        URL fields will be checked for keywords/URLs when new submissions is received.</font></p>
      </blockquote>
      <blockquote>
        <p><font face="Verdana" size="1"><strong>Email Field</strong><br>
        Email addresses will be checked for keywords or email addresses when new submissions is
        received.<br>
        &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; <br>
        <strong>Referrer<br>
        </strong>If keywords or URL addresses matches a referrer trying to submit data, the
        submission will be blocked. What is a referrer? In this instance a referrer is a URL
        address somewhere on internet that is trying to submit data directly to the submission
        script. The submission form will most probably be bypassed having the effect of receiving
        a referrer. This is mostly useful if you want to block submissions from certain submission
        services.</font></p>
      </blockquote>
      <p><font face="Verdana" size="1">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
      </font></td>
    </tr>
  </table>
  </center></div>
</form>
</body>
</html>

END_OF_ADDF

}



sub addfilter
{

#### ERROR CHECKING
if ($q->param('keyword') eq "")
	{
	acs::problem_popup("You have to specify a keyword."); 
	exit;
	}


open (SFILT, ">> $data_dir/sfilter.dat");
 	print SFILT $q->param('keyword') . "\t" . 			### SPAM FILTER
					$q->param('matchmethod') . "\t" . 		### MATCH METHOD
					$q->param('wherematch') . "\n"; 		### WHAT TO MATCH
close (SFILT);


print <<END_OF_SADD;

<html>
<head>
<title>Spam Filter</title>
</head>
<body>
<table border="0" cellpadding="2" cellspacing="1" width="100%">
  <tr>
    <td width="1%" valign="top"><p align="center"><img
    src="$web_url/add.gif"></td>
    <td width="95%" valign="top" align="center"><p align="left"><font face="Arial" size="4"
    color="#000000"><strong>Filter Added<br>
    </strong></font><font face="Verdana" size="1"><a
    href="$admin_url/admin42.cgi?fct=ofunct&amp;B1=Add+New+Filter">Add Another Filter</a> | <a
    href="$admin_url/admin42.cgi">Click Here to Continue</a></font></td>
  </tr>
</table>
<hr noshade size="1" color="#C0C0C0">
<p>&nbsp;</p>
</body>
</html>

END_OF_SADD

}








sub savededited
{

#########

$fildata = &get_file_contents("$data_dir/sfilter.dat");
@fitems = split (/\n/, $fildata);

$blc = 0;

foreach $item (@fitems)
	{
	$wMatchmethod = "matchmethod" . $blc;

	if ($q->param($wMatchmethod) ne "")
		{
		$wKeyword = "keyword" . $blc;
		$wWherematch = "wherematch" . $blc;
		
		if ($q->param($wKeyword) eq ""){$sError = "true";}
		
		$towrite[$blc] = 	$q->param($wKeyword) . "\t" . 		### KEYWORD
								$q->param($wMatchmethod) . "\t" . 	### MATCH METHOD
								$q->param($wWherematch);
		}
		else
		{
		$towrite[$blc] = $fitems[$blc];
		}

	$blc++;
	}


if ($sError eq "true")
	{
	acs::problem_popup("A keyword field was left blank.");  exit;
	}
	else
	{
	open (KWD, "> $data_dir/sfilter.dat");

	
		foreach $item (@towrite)
			{
			print KWD "$item\n";
			}
			
	close (KWD);  

print <<END_OF_SAVED;

<html>

<head>
<title>Edit Spam Filter(s)</title>
</head>
<body>
<table border="0" cellpadding="0" cellspacing="0" width="100%">
  <tr>
    <td width="6%" valign="top"><img src="$web_url/add.gif"></td>
    <td width="94%" valign="top"><strong><font face="Arial" size="4" color="#000000">Filter(s)
    Saved<br>
    </font></strong><a href="$admin_url/admin42.cgi"><font face="Verdana" size="1"
    color="#000000">Click here to continue</font></a></td>
  </tr>
</table>
<hr noshade size="1" color="#EBEBEB">
</body>
</html>

END_OF_SAVED

	}


}







sub editkeyw
{

$edit_html = <<END_OF_TOPK;

<html>

<head>
<title>Edit Spam Filter(s)</title>
</head>

<body>
<table border="0" cellpadding="0" cellspacing="0" width="100%">
  <tr>
    <td width="6%" valign="top"><img src="$web_url/add.gif"></td>
    <td width="94%" valign="top"><font face="Arial" size="4" color="#000000"><strong>Edit
    Filter(s)</strong></font></td>
  </tr>
</table>

<hr noshade size="1" color="#EBEBEB">

<form method="POST" action="$admin_cgi15">
<input type="hidden" name="fct" value="savededited">
<input type="hidden" name="maxc" value="$fields{'maxc'}">

END_OF_TOPK


$fildata = &get_file_contents("$data_dir/sfilter.dat");
@fitems = split (/\n/, $fildata);

for ($ms = 0; $ms <= $q->param('maxc'); $ms++)
	{
		$vname = "C" . $ms;
		
		if ($q->param($vname) ne "")
			{

			($tkey, $kmatch, $wmatch) = split(/\t/, $fitems[$ms]);
			
			$kf_name = "keyword" . $ms;
			$kf_matchmethod = "matchmethod" . $ms;
			$kf_wherematch = "wherematch" . $ms;
			
			### SELECTIONS
			$wsel = ""; $psel = ""; $sGeneral = ""; $sEmail = ""; $sURL = ""; $sReferer = "";
			
			if ($kmatch eq "W"){$wsel = "selected";} else {$psel = "selected";}
			
			if ($wmatch eq "General"){$sGeneral = "selected";}
			elsif ($wmatch eq "Email"){$sEmail = "selected";}
			elsif ($wmatch eq "URL"){$sURL = "selected";}
			elsif ($wmatch eq "Referer"){$sReferer = "selected";}

			
$edit_html = $edit_html . <<END_OF_EDITB;
<table border="0" cellpadding="3" cellspacing="1" width="100%" bgcolor="#C0C0C0">
  <tr>
    <td width="32%" bgcolor="#F4F4F4"><font face="Verdana" size="1"><strong>Keyword:</strong></font></td>
    <td width="68%" bgcolor="#FFFFFF"><input type="text" name="$kf_name" size="33"
    value="$tkey" style="font-family: MS Sans Serif; font-size: 8"></td>
  </tr>
  <tr>
    <td width="32%" bgcolor="#F4F4F4"><font face="Verdana" size="1"><strong>Whole or Partial
    Word Match:</strong></font></td>
    <td width="68%" bgcolor="#FFFFFF"><select name="$kf_matchmethod" size="1"
    style="font-family: MS Sans Serif; font-size: 8">
      <option $wsel value="W">Whole</option>
      <option $psel value="P">Partial</option>
    </select></td>
  </tr>
  <tr>
    <td width="32%" bgcolor="#F4F4F4"><font face="Verdana" size="1"><strong>Check For This
    Keyword in:</strong></font></td>
    <td width="68%" bgcolor="#FFFFFF"><select name="$kf_wherematch" size="1"
    style="font-family: MS Sans Serif; font-size: 8">
      <option $sGeneral value="General">Title, Description and Keyword Field</option>
      <option $sEmail value="Email">Email Field</option>
      <option $sURL value="URL">URL Field</option>
      <option $sReferer value="Referer">Referer</option>
    </select></td>
  </tr>
</table>
<br>
END_OF_EDITB

			$isel = "true";
			}

	}


###########

if ($isel eq "true")
	{

$edit_html = $edit_html . <<END_OF_FEND;
<input type="submit" value="   Save   " name="B1">
</form>
END_OF_FEND

	}
	else
	{
	acs::problem_popup("You have to check a checkbox next to a keyword to edit it."); 
	exit;

	}

print $edit_html;

}





sub start
{

$fildata = &get_file_contents("$data_dir/sfilter.dat");

if ($fildata ne "")
	{

	@fitems = split (/\n/, $fildata);
	
	$vcount = 0;

	foreach $fline (@fitems)
	{
	($fkey, $matchmethod, $wherematch) = split (/\t/, $fline);
		
		#### TITLES, DESCRIPTIONS AND KEYWORDS
		if ($wherematch eq "General")
			{
			$selval = "C" . $vcount;
			if ($matchmethod eq "W"){$matchmethod = "Whole";}
			else {$matchmethod = "Partial";}
			
			$genkeys = $genkeys . "<tr>";
			$genkeys = $genkeys . "<td width=\"82%\" bgcolor=\"#FFFFFF\" height=\"15\"><font face=\"Verdana\" size=\"1\"><input type=\"checkbox\" name=\"$selval\" value=\"$fkey\"> $fkey</font></td>";
    		$genkeys = $genkeys . "<td width=\"13%\" bgcolor=\"#FFFFFF\" height=\"15\"><font face=\"Verdana\" size=\"1\"><strong><div align=\"center\"><center><p></strong>$matchmethod<strong></strong></font></td>";
      	$genkeys = $genkeys . "</tr>";
			}
		
		#### EMAILS
		elsif ($wherematch eq "Email")
			{
			$selval = "C" . $vcount;
			if ($matchmethod eq "W"){$matchmethod = "Whole";}
			else {$matchmethod = "Partial";}
			
			$emailkeys = $emailkeys . "<tr>";
			$emailkeys = $emailkeys . "<td width=\"82%\" bgcolor=\"#FFFFFF\" height=\"15\"><font face=\"Verdana\" size=\"1\"><input type=\"checkbox\" name=\"$selval\" value=\"$fkey\"> $fkey</font></td>";
    		$emailkeys = $emailkeys . "<td width=\"13%\" bgcolor=\"#FFFFFF\" height=\"15\"><font face=\"Verdana\" size=\"1\"><strong><div align=\"center\"><center><p></strong>$matchmethod<strong></strong></font></td>";
      	$emailkeys = $emailkeys . "</tr>";
			}
			
		#### URL
		elsif ($wherematch eq "URL")
			{
			$selval = "C" . $vcount;
			if ($matchmethod eq "W"){$matchmethod = "Whole";}
			else {$matchmethod = "Partial";}
			
			$URLkeys = $URLkeys . "<tr>";
			$URLkeys = $URLkeys . "<td width=\"82%\" bgcolor=\"#FFFFFF\" height=\"15\"><font face=\"Verdana\" size=\"1\"><input type=\"checkbox\" name=\"$selval\" value=\"$fkey\"> $fkey</font></td>";
    		$URLkeys = $URLkeys . "<td width=\"13%\" bgcolor=\"#FFFFFF\" height=\"15\"><font face=\"Verdana\" size=\"1\"><strong><div align=\"center\"><center><p></strong>$matchmethod<strong></strong></font></td>";
      	$URLkeys = $URLkeys . "</tr>";
			}
	
		#### REFERRER
		elsif ($wherematch eq "Referer")
			{
			$selval = "C" . $vcount;
			if ($matchmethod eq "W"){$matchmethod = "Whole";}
			else {$matchmethod = "Partial";}
			
			$REFkeys = $REFkeys . "<tr>";
			$REFkeys = $REFkeys . "<td width=\"82%\" bgcolor=\"#FFFFFF\" height=\"15\"><font face=\"Verdana\" size=\"1\"><input type=\"checkbox\" name=\"$selval\" value=\"$fkey\"> $fkey</font></td>";
    		$REFkeys = $REFkeys . "<td width=\"13%\" bgcolor=\"#FFFFFF\" height=\"15\"><font face=\"Verdana\" size=\"1\"><strong><div align=\"center\"><center><p></strong>$matchmethod<strong></strong></font></td>";
      	$REFkeys = $REFkeys . "</tr>";
			}

	$vcount++;

	}

} #### END OF CHECK FOR ITEMS




if ($genkeys eq "")
	{
	$genkeys = $genkeys . "<tr>";
	$genkeys = $genkeys . "<td width=\"82%\" bgcolor=\"#FFFFFF\" height=\"15\"><font face=\"Verdana\" size=\"1\">No Keyword Filters Defined</font></td>";
	$genkeys = $genkeys . "<td width=\"13%\" bgcolor=\"#FFFFFF\" height=\"15\"><font face=\"Verdana\" size=\"1\"><strong><div align=\"center\"><center><p></strong>None<strong></strong></font></td>";
  	$genkeys = $genkeys . "</tr>";
	}

if ($emailkeys eq "")
	{
	$emailkeys = $emailkeys . "<tr>";
	$emailkeys = $emailkeys . "<td width=\"82%\" bgcolor=\"#FFFFFF\" height=\"15\"><font face=\"Verdana\" size=\"1\">No Keyword Filters Defined</font></td>";
	$emailkeys = $emailkeys . "<td width=\"13%\" bgcolor=\"#FFFFFF\" height=\"15\"><font face=\"Verdana\" size=\"1\"><strong><div align=\"center\"><center><p></strong>None<strong></strong></font></td>";
  	$emailkeys = $emailkeys . "</tr>";	
	}

if ($URLkeys eq "")
	{
	$URLkeys = $URLkeys . "<tr>";
	$URLkeys = $URLkeys . "<td width=\"82%\" bgcolor=\"#FFFFFF\" height=\"15\"><font face=\"Verdana\" size=\"1\">No Keyword Filters Defined</font></td>";
	$URLkeys = $URLkeys . "<td width=\"13%\" bgcolor=\"#FFFFFF\" height=\"15\"><font face=\"Verdana\" size=\"1\"><strong><div align=\"center\"><center><p></strong>None<strong></strong></font></td>";
  	$URLkeys = $URLkeys . "</tr>";		
	}

if ($REFkeys eq "")
	{
	$REFkeys = $REFkeys . "<tr>";
	$REFkeys = $REFkeys . "<td width=\"82%\" bgcolor=\"#FFFFFF\" height=\"15\"><font face=\"Verdana\" size=\"1\">No Keyword Filters Defined</font></td>";
	$REFkeys = $REFkeys . "<td width=\"13%\" bgcolor=\"#FFFFFF\" height=\"15\"><font face=\"Verdana\" size=\"1\"><strong><div align=\"center\"><center><p></strong>None<strong></strong></font></td>";
  	$REFkeys = $REFkeys . "</tr>";			
	}


print <<END_OF_FILTER;

<html>
<head>
<title>Spam Filter</title>
</head>
<body>

<table border="0" cellpadding="0" cellspacing="0" width="100%">
  <tr>
    <td width="6%" valign="top"><img src="$web_url/add.gif"></td>
    <td width="94%" valign="top"><font face="Arial" size="4" color="#000000"><strong>Spam
    Filter<br>
    </strong></font><font face="Verdana" size="1">The Spam/Keyword filter enables you to block
    submissions which you do not want included in your new submissions area for approval. This
    can be useful to completely ignore spam, a spammer, or to keep your directory family
    friendly. Note that once you added keywords here, the submission containing those keywords
    will be blocked completely and the blocked submission will only show in the 'blocked log'.
    The submitter will get the idea he submitted successfully but the submission will have
    been in fact blocked. <strong>Use with caution</strong> as you can block submissions that
    you don't want blocked. <strong>Make sure you understand how this works, before using it.</strong>
    See the online documentation for complete information.</font></td>
  </tr>
</table>

<hr noshade size="1" color="#EBEBEB">

<form method="POST" action="$admin_url/admin42.cgi">
  <input type="hidden" name="fct" value="filteraction">
  <input type="hidden" name="maxc" value="$vcount">
  
  <div align="center"><center>
  
  <table border="0" cellpadding="3" cellspacing="1" width="100%" bgcolor="#C0C0C0" height="221">
    <tr>
      <td width="60%" bgcolor="#8080C0" height="40"><strong><font color="#FFFFFF" face="Verdana" size="1">Keywords To Filter</font></strong></td>
      <td width="40%" bgcolor="#8080C0" height="40"><font color="#FFFFFF" face="Verdana" size="1"><strong><div align="center"><center><p>Match Method</strong></font></td>
    </tr>
    <tr>
      <td bgcolor="#FFD017" colspan="2" height="21"><font face="Verdana" size="1"><strong>Title, Description Keyword Field Filter<br>
      </strong>If a keyword (that you specified) is found in the title, description or keyword field when a new submission is submitted (by a user); the submission will be blocked.</font></td>
    </tr>
$genkeys
    <tr>
      <td width="100%" bgcolor="#FFD017" colspan="2" height="28"><font face="Verdana" size="1"><strong>Email Field Filter <br>
      </strong>If an email address is matched (partial or whole), the new submission will be blocked.</font></td>
    </tr>

$emailkeys
    
    <tr>
      <td width="100%" bgcolor="#FFD017" colspan="2" height="28"><font face="Verdana" size="1"><strong>URL Field Filter<br>
      </strong>If a URL/Domain address is matched (partial or whole), the new submission will be blocked.<strong></strong></font></td>
    </tr>

$URLkeys
    
    <tr>
      <td width="100%" bgcolor="#FFD017" height="15" colspan="2"><font face="Verdana" size="1"><strong>Referrer
      Blocking<br>
      </strong>'Referrer blocking' can be useful to block submission services from submitting
      URLs to your directory.<strong></strong></font></td>
    </tr>

$REFkeys

    <tr>
      <td width="100%" bgcolor="#FFD017" colspan="2" height="27"><font face="Verdana" size="1"></font>
      <input type="submit" value="   Edit   " name="B1" style="font-family: MS Sans Serif; font-size: 8"> 
      <input type="submit" value="Delete" name="B1" style="font-family: MS Sans Serif; font-size: 8"> 
      <font face="Verdana" size="1"> Check filters to edit or delete.</font>
    </tr>
  </table>
  </center></div>
</form>


<form method="POST" action="$admin_url/admin42.cgi">
  <input type="hidden" name="fct" value="ofunct"><table border="0" cellspacing="1"
  width="100%" cellpadding="6" bgcolor="#C0C0C0">
    <tr>
      <td width="1%" bgcolor="#F4F4F4"><input type="submit" value="Add New Filter" name="B1"
      onClick="popup('$admin_cgi15?fct=addnewfilter',600,400);return false;"
      style="font-family: MS Sans Serif; font-size: 8"></td>
      <td width="99%" bgcolor="#FFFFFF"><font face="Verdana" size="1"> Add a new filter, to
      filter spam submissions.</font></td>
    </tr>
    <tr>
      <td width="1%" bgcolor="#F4F4F4"><input type="submit" value="View Blocked Log" name="B1"
      style="font-family: MS Sans Serif; font-size: 8"></td>
      <td width="99%" bgcolor="#FFFFFF"><font face="Verdana" size="1">View what submissions have
      been blocked.</font></td>
    </tr>
    <tr>
      <td width="1%" bgcolor="#F4F4F4"><input type="submit" value="Delete Blocked Log" name="B1"
      style="font-family: MS Sans Serif; font-size: 8"></td>
      <td width="99%" bgcolor="#FFFFFF"><font face="Verdana" size="1">Clear the 'Blocked' log.
      Do this often if you have many filters, as the log can take up disk space.</font></td>
    </tr>
  </table>
</form>


<p><font face="Verdana" size="1"><strong>Spam/Keyword Filter Help<br>
</strong>&nbsp;&nbsp; <br>
If any of the keywords you added here are found in the new submissions fields (form fill-in
boxes), the submission is blocked. Keywords are matched partially or via
whole words.</font></p>

<p><font color="#ff8000" face="Verdana" size="1"><strong>&nbsp;&nbsp;&nbsp; What is Whole
or Partial Word Matches?</strong></font></p>

<blockquote>
  <p><font face="Verdana" size="1"><strong>Whole Word Matching:<br>
  </strong>'Whole word matching' matches whole words. For example: <strong>Spam</strong><br>
  This will only match <strong>Spam</strong> and not <strong>Spammed<br>
  &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp; <br>
  Partial Word Matching:<br>
  </strong>'Partial matching', matches any word in words. Let's say you specified <strong>Spam</strong>
  as a keyword. If <strong>Spammed</strong> was found within a submission, the submission
  would be blocked because <strong>Spammed</strong> contained the word <strong>Spam</strong></font></p>
  <p><font face="Verdana" size="1"><strong>Note that the keywords you specify is not case
  sensitive</strong></font></p>
</blockquote>

<p><font face="Verdana" size="1">See the<strong> PowerSeek documentation </strong>for
complete information.</font></p>


</body>
</html>

END_OF_FILTER


}




####################################################################################


sub get_setup
{

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^ADMIN_URL/){$admin_url = &get_setup_line($line, ADMIN_URL);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^WEB_DIR/){$web_dir = &get_setup_line($line, WEB_DIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}

if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}


			}
	close (STP);
	
	}
}




sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################

